<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsBill1 extends JPlugin
{
	function plgAnalyticsBill1( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		require_once (JPATH_ROOT .DS.'administrator'.DS.'components'.DS.'com_jsbill'.DS.'controllers'.DS.'cnf.php');
		jimport('joomla.filesystem.file');
		BillControllerCnf::initialyze();
	}
	
    function onGetChartTypes(&$data, $name) {
		
		if($name != 'bill1') return;
		
		$data = array('amline');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
		if($name != 'bill1') return;
		global $mainframe;
		if( !JComponentHelper::isEnabled('com_jsbill', true) )
		{
		    $errors = '<h3>Mighty Invoice v.2 Component Not Exists or Not Enabled<h3>';
			return;
		}

		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->addLabel("<![CDATA[This graph shows total income by days]]>",20 ,385 , array('text_size' => 10));
		$objChart->addLabel("<![CDATA[<b>Billing Income Progress</b>]]>",15 ,25 , array('text_size' => 16));
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'bill1' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc  = JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		

		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}

			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}

		$form .= '</table>';
	}

	function onChartData(&$objChart, $name, $params)
	{
		if($name != 'bill1') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));
		$groupby = $params->get('groupby', 'sday');

		if($params->get('bill'))
		{
			if(is_array($params->get('bill'))){
				$ids = implode(", ", $params->get('bill'));
			} else {
				$ids = $params->get('bill');
			}
		} else {
			$ids = false;
		}
		$sql = "
		SELECT ROUND(sum(p.total), 2) as ptotal, count(b.id) as total,
		DAYOFYEAR(p.ctime) as sday,
		WEEKOFYEAR(p.ctime) as sweek,
		MONTH(p.ctime) AS smonth,
		DATE_FORMAT(p.ctime , '%d, %b') AS dat_sday,
		CONCAT('Week - ', DATE_FORMAT(p.ctime , '%U')) AS dat_sweek,
		DATE_FORMAT(p.ctime , '%b') AS dat_smonth
		FROM #__bills_invoice AS p LEFT JOIN #__bills AS b	ON b.id = p.bill_id
		WHERE p.ctime > '$from'".
		($ids ? " AND b.id IN ($ids) " : null)
		."AND p.ctime < '$to'
		AND p.published = 1 ";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND p.user_id = '$user_id'";
		$sql .= " GROUP BY `{$groupby}`
		ORDER BY p.ctime  DESC";
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if(!$result) return;


		$graph = array();

		$total = 0;
		$sale = 0;
		foreach ($result AS $key => $row)
		{
			$objChart->addSerie($key, $row->{"dat_".$groupby});
			$graph[2][$key] = $row->ptotal;
			$graph[1][$key] = $row->total;
			$total += $row->total;
			$sale += $row->ptotal;
		}
		foreach ($result AS $key => $row)
		{
			$graph[3][$key] = round(($total / count($result)),2);
			$graph[4][$key] = round(($sale / count($result)),2);
		}
		
		$i = 1;
		$objChart->addGraph($i, JText::_('Count Transactions'), $graph[$i++], array( 
			'balloon_text' => '<![CDATA[<b>{value}</b>]]>',
			'color' => '#cccc66',
			'axis' => 'left'
		));
		
		$objChart->addGraph($i, JText::_('Sales total'), $graph[$i++], array( 
			'balloon_text' => '<![CDATA[<b>${value}</b>]]>',
			'color' => '#920053',
			'axis' => 'right',
			'line_width' => '2',
		    'color_hover' => '#586835',
	        'bullet' => 'square' 
		));
		
		$objChart->addGraph($i, JText::_('Average count'), $graph[$i++], array( 
			'balloon_text' => '<![CDATA[<b>{value}</b>]]>',
			'color' => '#003399',
			'axis' => 'left',
			'color_hover' => '#0033cc',
			'fill_color' => '#003399',
			'bullet' => 'square',
			'line_width' => '2',
		    'line_alpha' => 30,
            'fill_alpha' => 5,
			'selected' => 'false'
		));
		
		$objChart->addGraph($i, JText::_('Average Sale'), $graph[$i], array( 
			'balloon_text' => '<![CDATA[<b>${value}</b>]]>',
			'color' => '#920053',
			'axis' => 'right',
			'color_hover' => '#996699',
		    'line_width' => '2',
			'line_alpha' => '30',
            'bullet' => 'square',
            'selected' => 'false'
		));
	}
	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'bill1') return;

		$user = JFactory::getUser();
		$user_id = 0;
		if($params->get('user_stick'))
		{
			$user_id = $user->id;
		}
		if($user->gid == 25) $user_id = JRequest::getInt('user_id', $user_id);

		$db = JFactory::getDBO();

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		$groupby = $params->get('groupby', 'sday');
		$limit      = $params->get('limit', 0);
		
		$sort_by = $params->get('sort_by', 'p.ctime  DESC');

		if($params->get('bill'))
		{
			if(is_array($params->get('bill'))){
				$ids = implode(", ", $params->get('bill'));
			} else {
				$ids = $params->get('bill');
			}
		}
		else
		{
			$ids = false;
		}

		$sql = "
		SELECT ROUND(sum(p.total), 2) as ptotal, count(b.id) as count, p.name, p.total, p.params, p.product_list,
		DAYOFYEAR(p.ctime) as sday,
		WEEKOFYEAR(p.ctime) as sweek,
		MONTH(p.ctime) AS smonth,
		DATE_FORMAT(p.ctime , '%d, %b') AS dat_sday,
		CONCAT('Week - ', DATE_FORMAT(p.ctime , '%U')) AS dat_sweek,
		DATE_FORMAT(p.ctime , '%b') AS dat_smonth
		FROM #__bills_invoice AS p LEFT JOIN #__bills AS b	ON b.id = p.bill_id
		WHERE p.ctime > '$from'".
		($ids ? " AND b.id IN ($ids) " : null)
		."AND p.ctime < '$to'
		AND p.published = 1";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND p.user_id = '$user_id'";
		$sql .= " GROUP BY b.id, `{$groupby}`
		ORDER BY {$sort_by}";
		if($limit)
		$sql .= " LIMIT 0, $limit";

		$db->setQuery($sql); 
		$result = $db->loadObjectList();

		if(!$result) return;

		$k = 0;
		$total = array();
		$i = 1;

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th width="1%">'.JText::_('Date').'</th>';
		$out[] = '<th class="title">'.JText::_('Bill Name').'</th>';
		$out[] = '<th width="1%" nowrap>'.JText::_('Unit Price').'</th>';
		$out[] = '<th width="1%">'.JText::_('Count').'</th>';
		$out[] = '<th width="1%">'.JText::_('Total').'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		foreach ($result AS $p => $row)
		{
			$k = 1 - $k;
			$pparams = new JParameter($row->params);
			if(!isset($total[$pparams->get('curr')])) $total[$pparams->get('curr')] = $row->ptotal;
			else $total[$pparams->get('curr')] += $row->ptotal;
			$out[] = '
			<tr class="row'.$k.'">
				<td>'.$i.'</td>
				<td nowrap>'.$row->{"dat_".$groupby}.'</td>
				<td>'.$row->name.'</td>
				<td align="right">'.str_replace(array("00", 'Sign'), array($row->total, $pparams->get('curr')), BILL_PRICE).'</td>
				<td align="center">'.$row->count.'</td>
				<td align="right">'.str_replace(array("00", 'Sign'), array($row->ptotal, $pparams->get('curr')), BILL_PRICE).'</td>
				</tr>';
			$i ++;

		}
		foreach ($total as $curr => $res)
		$out[] = '
		<tr>
			<td colspan="5" align="right"><b>'.JText::_('Total').'</b></td>
			<td nowrap><b><big>'.str_replace(array("00", 'Sign'), array($res, $curr), BILL_PRICE).'</big></b></td>
			</tr>';
		$out[] = '</tbody></table>';
		$table = implode("", $out);
		if($params->get('rep_xls')) {
			jimport( 'joomla.filesystem.file' );
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}

	function onGetTotals($name, $params)
	{
		if($name != 'bill1') return;
		
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = 0;
		if($params->get('user_stick'))
		{
			$user_id = $user->id;
		}
		if($user->gid == 25) $user_id = JRequest::getInt('user_id', $user_id);

		$db = JFactory::getDBO();

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		$groupby = $params->get('groupby', 'sday');

		if($params->get('bill'))
		{
			if(is_array($params->get('bill'))){
				$ids = implode(", ", $params->get('bill'));
			} else {
				$ids = $params->get('bill');
			}
		}
		else
		{
			$ids = false;
		}

		$totals = array();

		$sql = "
		SELECT COUNT(p.id) as total
		FROM #__bills_invoice AS p LEFT JOIN #__bills AS b	ON b.id = p.bill_id
		WHERE p.ctime > '$from'".
		($ids ? " AND b.id IN ($ids) " : null)
		."AND p.ctime < '$to'
		AND p.published = 1";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND p.user_id = '$user_id'";
		//$sql .= " GROUP BY b.id, `{$groupby}`";
		$db->setQuery( $sql ); 
		if($res = $db->loadResult())
		{
			$totals[0]['value'] = $res;
			$totals[0]['text'] = JText::_( 'Total invoices amount' );
		}
		$sql = "
		SELECT p.total, p.params
		FROM #__bills_invoice AS p LEFT JOIN #__bills AS b	ON b.id = p.bill_id
		WHERE p.ctime > '$from'".
		($ids ? " AND b.id IN ($ids) " : null)
		."AND p.ctime < '$to'
		AND p.published = 1";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND p.user_id = '$user_id'";
		//$sql .= " GROUP BY b.id, `{$groupby}`";
		$db->setQuery( $sql ); 
		if($res = $db->loadObjectList())
		{
			$value = array();
			foreach ($res as $val)
			{
				$pparams = new JParameter($val->params);
				$c = $pparams->get('curr');
				if( !isset($value[$c]) ) 
				    $value[$c] = $val->total;
				else
				    $value[$c] += $val->total;
			}
			$i = 1;
			foreach ($value as $curr => $val)
			{
				$totals[$i]['value'] = $val;
				$totals[$i]['text'] = JText::_( 'Total in' ). ' '.$curr;
				$i ++;
			}
		}
		return $totals;
	}
}
?>